<?php

namespace Hepsipay\Payment\Controller\Response;

use Magento\Checkout\Api\GuestPaymentInformationManagementInterface;
use Magento\Customer\Model\Session;
use Magento\Framework\App\Action\Action;
use Magento\Framework\App\Action\Context;
use Magento\Framework\App\Config\ScopeConfigInterface;
use Magento\Framework\App\Request\Http;
use Magento\Framework\Controller\Result\JsonFactory;
use Magento\Framework\Controller\ResultFactory;
use Hepsipay\Payment\Helper\ApiService;
use Magento\Framework\App\CsrfAwareActionInterface;
use Magento\Framework\App\RequestInterface;
use Magento\Framework\App\Request\InvalidRequestException;
use Magento\Framework\App\Action\HttpPostActionInterface;
use Magento\Framework\Json\EncoderInterface;
use Magento\Framework\Message\ManagerInterface;
use Magento\Framework\View\Result\LayoutFactory;
use Magento\Framework\View\Result\PageFactory;
use Magento\Quote\Api\CartManagementInterface;
use Magento\Quote\Api\CartRepositoryInterface;
use Magento\Quote\Model\Quote;
use Magento\Quote\Model\QuoteIdMaskFactory;
use Magento\Store\Model\StoreManagerInterface;

class CheckoutForm extends Action implements CsrfAwareActionInterface, HttpPostActionInterface {

	protected $_context;
	protected $_pageFactory;
	protected $_jsonEncoder;
	protected $_checkoutSession;
	protected $_customerSession;
	protected $_quote;
	protected $_cartManagement;
	protected $_resultRedirect;
	protected $_resultJsonFactory;
	protected $_quoteRepository;
	protected $_scopeConfig;
	protected $_request;
	protected $_messageManager;
	protected $_guestCartManagement;
	protected $_storeManager;
	protected $quoteIdMaskFactory;

	/**
	 * @var LayoutFactory
	 */
	private $resultLayoutFactory;

	public function __construct(
		Context $context,
		EncoderInterface $encoder,
		PageFactory $pageFactory,
		\Magento\Checkout\Model\Session $checkoutSession,
		Session $customerSession,
		Quote $quote,
		CartManagementInterface $cartManagement,
		ResultFactory $resultFactory,
		JsonFactory $resultJsonFactory,
		CartRepositoryInterface $quoteRepository,
		ScopeConfigInterface $scopeConfig,
		Http $request,
		ManagerInterface $messageManager,
		GuestPaymentInformationManagementInterface $guestCartManagement,
		StoreManagerInterface $storeManager,
		QuoteIdMaskFactory $quoteIdMaskFactory,
		LayoutFactory $resultLayoutFactory
	) {
		parent::__construct( $context );
		$this->_resultJsonFactory = $resultJsonFactory;
		$this->_pageFactory = $pageFactory;
		$this->_jsonEncoder = $encoder;
		$this->_checkoutSession = $checkoutSession;
		$this->_customerSession = $customerSession;
		$this->_quote = $quote;
		$this->_cartManagement = $cartManagement;
		$this->_resultRedirect = $context->getResultFactory();
		$this->_quoteRepository = $quoteRepository;
		$this->_scopeConfig = $scopeConfig;
		$this->_request = $request;
		$this->_messageManager = $messageManager;
		$this->_guestCartManagement = $guestCartManagement;
		$this->_storeManager = $storeManager;
		$this->quoteIdMaskFactory = $quoteIdMaskFactory;
		$this->resultLayoutFactory = $resultLayoutFactory;
	}

	/**
	 * @inheritDoc
	 */
	public function createCsrfValidationException(
		RequestInterface $request
	): ?InvalidRequestException {
		return null;
	}

	/**
	 * @inheritDoc
	 */
	public function validateForCsrf( RequestInterface $request ): ?bool {
		return true;
	}

	public function execute() {
		$postData = $this->getRequest()->getPostValue();

		$resultRedirect->setPath( 'checkout/onepage/success', [ '_secure' => true ] );

		return $resultRedirect;
	}
}
