<?php

declare( strict_types=1 );

namespace Hepsipay\Payment\Plugin;

use Magento\Framework\App\Request\Http;
use Magento\Framework\Session\SessionStartChecker;

class TransparentSessionChecker {
	/**
	 * @var Http
	 */
	private $request;

	/**
	 * @param  Http  $request
	 */
	public function __construct(
		Http $request
	) {
		$this->request = $request;
	}

	/**
	 *
	 * @param  SessionStartChecker  $subject
	 * @param  bool  $result
	 *
	 * @return bool
	 * @SuppressWarnings(PHPMD.UnusedFormalParameter)
	 */
	public function afterCheck( SessionStartChecker $subject, bool $result ): bool {
		if ( $result === false ) {
			return false;
		}

		$path = (string) $this->request->getPathInfo();

		return strpos( $path, 'Hepsipay_Payment/transparent/redirect' ) === false;
	}
}
